var myCodeMirror;
var myCodeMirrorCRM;
var myCodeMirrorQR;
var myCodeMirrorAR;
var myCodeMirrorAH;
var myCodeMirrorCSATSurvey;
var myCodeMirrorCSATFeedback;
var myCodeMirrorCSATBye;
var myCodeMirrorTemplates;


document.addEventListener('DOMContentLoaded', (event) => {

    $('input[name="chatbroker_use_business_hours"]').first().parent().css('float','left').after('<div>&nbsp;(<a data-trans="manage" href="javascript:void(0);" onclick="javascript:bh();">manage</a>)</div>');
    //$(".chk3").bootstrapSwitch();
    $('.dtp').datetimepicker({ format: 'HH:mm', useCurrent: false });

    $(".dtp").on("dp.change", function (e) {
        var day = $(e.target).attr('id').split('_')[0];
        var when = $(e.target).attr('id').split('_')[1];
        if(when=='start') {
            $('#'+day+'_end').data("DateTimePicker").minDate(e.date);
        } else {
            $('#'+day+'_start').data("DateTimePicker").maxDate(e.date);
        }
    });

    $('.chk3').on('change',function(ev) {
         var day = $(ev.currentTarget).attr('id').split('_')[0];
         if (ev.currentTarget.checked) {
            $('#'+day+'_start').prop('disabled',false);
            $('#'+day+'_end').prop('disabled',false);
            if($('#'+day+'_start').val()=='') { $('#'+day+'_start').val('09:00') }
            if($('#'+day+'_end').val()=='') { $('#'+day+'_end').val('17:00') }
         } else {
            $('#'+day+'_start').val('').prop('disabled',true);;
            $('#'+day+'_end').val('').prop('disabled',true);;
         }
    });

    $('#businesshours').on('shown.bs.modal', function () {
        if(typeof(myCodeMirrorAH)=='undefined') {
        if($('#bhmsg').length>0) {
            myCodeMirrorAH = CodeMirror.fromTextArea($('#bhmsg')[0],{
              lineNumbers: true,
              lineWrapping: true,
              styleActiveLine: false,
              styleActiveSelected: false,
              mode: null,
              gutters: ["CodeMirror-lint-markers"],
              lint:false,
              extraKeys: { 
                 "':'": startEmoji,
              }
            });
          myCodeMirrorAH.setSize(null,150);
        }
    }


    });

    $('#businesshours').on('show.bs.modal', function () {
        val = $('#chatbroker_business_hours').val();
        msg = $('#chatbroker_after_hours_msg').val();
        $('#bhmsg').val(msg);
        if(val!='') {
            store_hours = JSON.parse($('#chatbroker_business_hours').val());

            for (const [key, value] of Object.entries(store_hours)) {
                  if(store_hours[key]['state']=='open') {
                     $('#'+key+'_enabled').prop('checked',true);
                     $('#'+key+'_start').val(store_hours[key]['start']);
                     $('#'+key+'_end').val(store_hours[key]['end']);
                  } else {
                     $('#'+key+'_enabled').prop('checked',false);
                     $('#'+key+'_start').val('').prop('disabled',true);
                     $('#'+key+'_end').val('').prop('disabled',true);
                  }
            }
            $('#timezone').val(store_hours['timezone']).trigger("chosen:updated");

        } else {
            $('.hourstart').val('');
            $('.hourend').val('');
        }

    
    })

    $('#businesshours').on('hide.bs.modal', function () {
         store_hours = {};
         $('.chk3').each(function(idx,el) {
             day = $(el).attr('name').split('_')[0];
             if($(el).is(':checked')) {
                state='open';
             } else {
                state='closed';
             }
             store_hours[day] = { "state": state };
         });
         $('.dtp').each(function(idx,el) {
             day = $(el).attr('id').split('_')[0];
             when = $(el).attr('id').split('_')[1];
             if(store_hours[day]['state']=='open') {
                 val = $(el).val();
             } else {
                 val = '';
             }
             store_hours[day][when] = val;
         });
         store_hours['timezone']=$('#timezone').val();
         $('#chatbroker_business_hours').val(JSON.stringify(store_hours));
         $('#chatbroker_after_hours_msg').val(myCodeMirrorAH.getValue());
    });

    if($('#chatbroker_template').length>0) {
        myCodeMirror = CodeMirror.fromTextArea($('#chatbroker_template')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: 'application/json',
          gutters: ["CodeMirror-lint-markers"],
          lint:true
        });
        myCodeMirror.setSize(null,150);
        if($('#chatbroker_template').val()=='') {
            updateTemplate(1);
        }
    }
    updateHelp();

    if($('#chatbroker_crmtemplate').length>0) {
        myCodeMirrorCRM = CodeMirror.fromTextArea($('#chatbroker_crmtemplate')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: 'application/json',
          gutters: ["CodeMirror-lint-markers"],
          lint:true
        });
        myCodeMirrorCRM.setSize(null,150);
        if($('#chatbroker_crmtemplate').val()=='') {
            updateCRMTemplate(1);
        }
    }

    // Quick Replies - Canned responses
    if($('#qrcontent').length>0) {
        myCodeMirrorQR = CodeMirror.fromTextArea($('#qrcontent')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: null,
          gutters: ["CodeMirror-lint-markers"],
          lint:true,
          extraKeys: { 
             "':'": startEmoji,
        }

        });
        myCodeMirrorQR.setSize(null,200);
    }

    // AutoReply
    if($('#chatbroker_autoreply').length>0) {
        myCodeMirrorAR = CodeMirror.fromTextArea($('#chatbroker_autoreply')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: null,
          gutters: ["CodeMirror-lint-markers"],
          lint:true,
          extraKeys: { 
             "':'": startEmoji,
        }

        });
        myCodeMirrorAR.setSize(null,150);
    }

    // CSAT Survey
    if($('#chatbroker_csat_msg').length>0) {
        myCodeMirrorCSATSurvey = CodeMirror.fromTextArea($('#chatbroker_csat_msg')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: null,
          gutters: ["CodeMirror-lint-markers"],
          lint:true,
          extraKeys: { 
             "':'": startEmoji,
        }

        });
        myCodeMirrorCSATSurvey.setSize(null,150);
    }

    // CSAT Feedback
    if($('#chatbroker_csat_feedback_msg').length>0) {
        myCodeMirrorCSATFeedback = CodeMirror.fromTextArea($('#chatbroker_csat_feedback_msg')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: null,
          gutters: ["CodeMirror-lint-markers"],
          lint:true,
          extraKeys: { 
             "':'": startEmoji,
        }

        });
        myCodeMirrorCSATFeedback.setSize(null,100);
    }

    // CSAT Bye
    if($('#chatbroker_csat_bye_msg').length>0) {
        myCodeMirrorCSATBye = CodeMirror.fromTextArea($('#chatbroker_csat_bye_msg')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: null,
          gutters: ["CodeMirror-lint-markers"],
          lint:true,
          extraKeys: { 
             "':'": startEmoji,
        }

        });
        myCodeMirrorCSATBye.setSize(null,100);
    }

    // Whatsapp templates
    if($('#chatbroker_whatsapp_templates').length>0) {
        myCodeMirrorTemplates = CodeMirror.fromTextArea($('#chatbroker_whatsapp_templates')[0],{
          lineNumbers: true,
          lineWrapping: true,
          styleActiveLine: true,
          styleActiveSelected: true,
          mode: 'application/json',
          gutters: ["CodeMirror-lint-markers"],
          lint:true
        });
        myCodeMirrorTemplates.setSize(null,150);
    }




    $('#chatbroker_engine').on('change',function(){
        updateTemplate(0);
        updateHelp();
    });

    $('#chatbroker_crm').on('change',function(){
        updateCRMTemplate(0);
    });

    if($('input[name="chatbroker_enable_csat"]').is(':checked')===false) {
        $('#chatbroker_csat_msg').parent().parent().fadeOut();
        $('#chatbroker_csat_feedback_msg').parent().parent().fadeOut();
        $('#chatbroker_csat_bye_msg').parent().parent().fadeOut();
    }

    $('input[name="chatbroker_enable_csat"]').on('change',function(ev){
       usecsat = $(ev.currentTarget).is(':checked');
       if(usecsat===true) {
           $('#chatbroker_csat_msg').parent().parent().fadeIn();
           $('#chatbroker_csat_feedback_msg').parent().parent().fadeIn();
           $('#chatbroker_csat_bye_msg').parent().parent().fadeIn();
       } else {
           $('#chatbroker_csat_msg').parent().parent().fadeOut();
           $('#chatbroker_csat_feedback_msg').parent().parent().fadeOut();
           $('#chatbroker_csat_bye_msg').parent().parent().fadeOut();
       }
    });

    if($('input[name="chatbroker_enable_ctia"]').is(':checked')===false) {
        $('#chatbroker_ctia_stop_msg').parent().parent().fadeOut();
        $('#chatbroker_ctia_stop_url').parent().parent().fadeOut();
        $('#chatbroker_ctia_help_msg').parent().parent().fadeOut();
    }

    $('input[name="chatbroker_enable_ctia"]').on('change',function(ev){
       usectia = $(ev.currentTarget).is(':checked');
       if(usectia===true) {
           $('#chatbroker_ctia_stop_msg').parent().parent().fadeIn();
           $('#chatbroker_ctia_stop_url').parent().parent().fadeIn();
           $('#chatbroker_ctia_help_msg').parent().parent().fadeIn();
       } else {
           $('#chatbroker_ctia_stop_msg').parent().parent().fadeOut();
           $('#chatbroker_ctia_stop_url').parent().parent().fadeOut();
           $('#chatbroker_ctia_help_msg').parent().parent().fadeOut();
       }
    });

    $('[data-trans]').each(function() {
         if(typeof(parent.lang[$(this).data('trans')])!='undefined') {
              newtext = parent.lang[$(this).data('trans')];
         } else {
             newtext = $(this).data('trans');
         }
         $(this).text(newtext);
    });

    $('#timezone').chosen();
});

function updateHelp() {
    $('#helpdid').remove();
    $('#helptemplate').remove();
    $('#helpengine').remove();
    engine = $('#chatbroker_engine').val();
    if(typeof(chatbrokertemplate)!='undefined') {
    if(typeof(chatbrokertemplate[engine])!='undefined') {
        let helpdata = JSON.parse(atob(chatbrokerfieldhelp[engine]));
        if(typeof(helpdata.did)=='string') {
            $('#chatbroker_did').parent().parent().children().first().append(`<i id="helpdid" style="margin:0 3px;" class="fa fa-question-circle iconhelp" data-toggle="popover" data-content="${helpdata.did}"></i>`);
        }
        if(typeof(helpdata.template)=='string') {
            $('#chatbroker_template').parent().parent().children().first().append(`<i id="helptemplate" style="margin:0 3px;" class="fa fa-question-circle iconhelp" data-toggle="popover" data-content="${helpdata.template}"></i>`);
        }
        if(typeof(helpdata.engine)=='string') {
            $('#chatbroker_engine').parent().parent().children().first().append(`<i id="helpengine" style="margin:0 3px;" class="fa fa-question-circle iconhelp" data-toggle="popover" data-content="${helpdata.engine}"></i>`);
        }
    }
    }
    $('[data-toggle="popover"]').popover({ container: 'body', html: true, trigger: 'hover' });
}

function updateTemplate(force) {
    engine = $('#chatbroker_engine').val();
    if(typeof(chatbrokertemplate[engine])!='undefined') {
         content = chatbrokertemplate[engine];
         if(content=='') {
             $('#chatbroker_template').next('.CodeMirror').hide();
             //$('.CodeMirror').hide();
         } else {
             content = atob(content);
             $('#chatbroker_template').next('.CodeMirror').show();
             //$('.CodeMirror').show();
             myCodeMirror.refresh();
             $('#chatbroker_template').val(content);
             myCodeMirror.setValue(content);
             myCodeMirror.refresh();
         }
    }

    if(typeof(chatbrokericon[engine])!='undefined') {
        $('#chatbroker_icon').val(chatbrokericon[engine]);
    }
}

function updateCRMTemplate(force) {
    crm = $('#chatbroker_crm').val();
    if(typeof(crmtemplate[crm])!='undefined') {
         $('#chatbroker_crmtemplate').next('.CodeMirror').parent().parent().show();
         content = crmtemplate[crm];
         if(content=='') {
             $('#chatbroker_crmtemplate').next('.CodeMirror').hide();
         } else {
             content = atob(content);
             $('#chatbroker_crmtemplate').next('.CodeMirror').show();
             myCodeMirrorCRM.refresh();
             $('#chatbroker_crmtemplate').val(content);
             myCodeMirrorCRM.setValue(content);
             myCodeMirrorCRM.refresh();
         }
    } else {
         $('#chatbroker_crmtemplate').next('.CodeMirror').parent().parent().hide();
    }
}

function bh() {
    $('#businesshours').modal();
}

function getCookie(name) {
    var cname = name + "=";
    var dc = document.cookie;
    if (dc.length > 0) {
        begin = dc.indexOf(cname);
        if (begin != -1) {
            begin += cname.length;
            end = dc.indexOf(";", begin);
            if (end == -1) {
                end = dc.length;
            }
            return unescape(dc.substring(begin, end));
        }
    }
    return null;
}
